#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Thu Mar  4 17:38:55 2021

@author: Mathilde
"""

import numpy as np

import matplotlib.pyplot as plt

### Q2

def euler(n):
    """
    La fonction prend en entrée un nombre n de points à construire et 
    résout l'équation y'=y sur l'intervalle [0,2] avec y0=1
    """
    pas = (2-0)/(n-1)
    #pas est le pas de la méthode d'Euler
    Liste_y=[1]
    #On va stocker les ordonnées dans Liste_y
    for i in range(n-1):
        y=Liste_y[i]+(Liste_y[i])*pas
        # On applique la méthode d'Euler pour construire le point 
        #suivant et on le rajoute dans la liste des ordonnées
        Liste_y=Liste_y+[y]
    return Liste_y

### Q3

def affiche_Euler(n):
    """
    Cette fonction affiche la courbe obtenue avec la 
    méthode d'Euler pour l'équation différentielle y'=y
    avec la condition initiale y(0)=1
    """
    abscisse=np.linspace(0,2,n)
    ordonnee_approx=euler(n)
    plt.plot(abscisse,ordonnee_approx,"-b")
  
### Q5
    
def affiche_exponentielle(n):
    #Cette fonction affiche la courbe de la fonction exponentielle entre 
    # 0 et 2 (solution exacte de l'équation différentielle y'=y)
    abscisse=np.linspace(0,2,n)
    ordonnee_exacte=np.exp(abscisse)
    plt.plot(abscisse,ordonnee_exacte,"-g")


### Q6
def affiche_compare(n):
    #Cette fonction affiche la courbe obtenue avec la 
    #méthode d'Euler ainsi que la courbe de la fonction
    #obtenue en résolvant l'équation différentielle y'=y
    #avec la condition initiale y(0)=1
    abscisse=np.linspace(0,2,n)
    ordonnee_approx=euler(n)
    ordonnee_exacte=np.exp(abscisse)
    plt.plot(abscisse,ordonnee_approx,"-b",abscisse,ordonnee_exacte,"-g")